package com.mortals.xhx.module.apply.service.impl;
import com.mortals.framework.util.DataUtil;
import com.mortals.framework.util.SecurityUtil;
import com.mortals.xhx.base.system.user.model.UserEntity;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.common.pdu.user.UserPhpPdu;
import com.mortals.xhx.module.apply.model.ApproverQuery;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.apply.dao.ApproverDao;
import com.mortals.xhx.module.apply.model.ApproverEntity;
import com.mortals.xhx.module.apply.service.ApproverService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;

import java.util.List;

/**
* ApproverService
* 单事项审批人员 service实现
*
* @author zxfei
* @date 2023-05-23
*/
@Service("approverService")
@Slf4j
public class ApproverServiceImpl extends AbstractCRUDServiceImpl<ApproverDao, ApproverEntity, Long> implements ApproverService {

    @Override
    public void updateUserList(List<UserPhpPdu> list) {
        if(!CollectionUtils.isEmpty(list)){
            for(UserPhpPdu phpPdu:list){
                if(!phpPdu.getType().equals("2")){
                    continue;
                }
                ApproverEntity tempUser = this.selectOne(new ApproverQuery().loginName(phpPdu.getAccount()));
                if (ObjectUtils.isEmpty(tempUser)) {
                    //新增
                    ApproverEntity approverEntity = new ApproverEntity();
                    approverEntity.initAttrValue();
                    approverEntity.setFullName(phpPdu.getUser_name());
                    approverEntity.setLoginName(phpPdu.getAccount());
                    try {
                        approverEntity.setLoginPwd(SecurityUtil.md5DoubleEncoding(phpPdu.getPassword()));
                    } catch (Exception e) {
                        throw new AppException("密码转换异常！", e);
                    }
                    approverEntity.setPhoneNumber(phpPdu.getMobile());
                    approverEntity.setSiteId(1l);
                    dao.insert(approverEntity);

                } else {
                    //更新
                    ApproverEntity approverEntity = new ApproverEntity();
                    approverEntity.setId(tempUser.getId());
                    approverEntity.initAttrValue();
                    approverEntity.setFullName(phpPdu.getUser_name());
                    approverEntity.setLoginName(phpPdu.getAccount());
                    try {
                        approverEntity.setLoginPwd(SecurityUtil.md5DoubleEncoding(phpPdu.getPassword()));
                    } catch (Exception e) {
                        throw new AppException("密码转换异常！", e);
                    }
                    approverEntity.setPhoneNumber(phpPdu.getMobile());
                    dao.update(approverEntity);
                }
            }
        }
    }
}